# TV Script Generation¶

In this project, you'll generate your own Simpsons TV scripts using RNNs. You'll be using part of the Simpsons dataset of scripts from 27 seasons. The Neural Network you'll build will generate a new TV script for a scene at Moe's Tavern.

## Get the Data¶

The data is already provided for you. You'll be using a subset of the original dataset. It consists of only the scenes in Moe's Tavern. This doesn't include other versions of the tavern, like "Moe's Cavern", "Flaming Moe's", "Uncle Moe's Family Feed-Bag", etc..

In [1]:

    """
    DON'T MODIFY ANYTHING IN THIS CELL
    """
    import helper

    data_dir = './data/simpsons/moes_tavern_lines.txt'
    text = helper.load_data(data_dir)
    # Ignore notice, since we don't use it for analysing the data
    text = text[81:]

## Explore the Data¶

Play around with `view_sentence_range` to view different parts of the data.

In [2]:

    view_sentence_range = (0, 10)

    """
    DON'T MODIFY ANYTHING IN THIS CELL
    """
    import numpy as np

    print('Dataset Stats')
    print('Roughly the number of unique words: {}'.format(len({word: None for word in text.split()})))
    scenes = text.split('\n\n')
    print('Number of scenes: {}'.format(len(scenes)))
    sentence_count_scene = [scene.count('\n') for scene in scenes]
    print('Average number of sentences in each scene: {}'.format(np.average(sentence_count_scene)))

    sentences = [sentence for scene in scenes for sentence in scene.split('\n')]
    print('Number of lines: {}'.format(len(sentences)))
    word_count_sentence = [len(sentence.split()) for sentence in sentences]
    print('Average number of words in each line: {}'.format(np.average(word_count_sentence)))

    print()
    print('The sentences {} to {}:'.format(*view_sentence_range))
    print('\n'.join(text.split('\n')[view_sentence_range[0]:view_sentence_range[1]]))

    Dataset Stats
    Roughly the number of unique words: 11492
    Number of scenes: 262
    Average number of sentences in each scene: 15.248091603053435
    Number of lines: 4257
    Average number of words in each line: 11.50434578341555

    The sentences 0 to 10:
    Moe_Szyslak: (INTO PHONE) Moe's Tavern. Where the elite meet to drink.
    Bart_Simpson: Eh, yeah, hello, is Mike there? Last name, Rotch.
    Moe_Szyslak: (INTO PHONE) Hold on, I'll check. (TO BARFLIES) Mike Rotch. Mike Rotch. Hey, has anybody seen Mike Rotch, lately?
    Moe_Szyslak: (INTO PHONE) Listen you little puke. One of these days I'm gonna catch you, and I'm gonna carve my name on your back with an ice pick.
    Moe_Szyslak: What's the matter Homer? You're not your normal effervescent self.
    Homer_Simpson: I got my problems, Moe. Give me another one.
    Moe_Szyslak: Homer, hey, you should not drink to forget your problems.
    Barney_Gumble: Yeah, you should only drink to enhance your social skills.

## Implement Preprocessing Functions¶

The first thing to do to any dataset is preprocessing. Implement the following preprocessing functions below:

- Lookup Table
- Tokenize Punctuation

### Lookup Table¶

To create a word embedding, you first need to transform the words to ids. In this function, create two dictionaries:

- Dictionary to go from the words to an id, we'll call `vocab_to_int`
- Dictionary to go from the id to word, we'll call `int_to_vocab`

Return these dictionaries in the following tuple `(vocab_to_int, int_to_vocab)`

In [11]:

    import numpy as np
    import problem_unittests as tests
    from collections import Counter

    def create_lookup_tables(text):
        """
        Create lookup tables for vocabulary
        :param text: The text of tv scripts split into words
        :return: A tuple of dicts (vocab_to_int, int_to_vocab)
        """
        # TODO: Implement Function
        words_counter = Counter(text)
        unique_words = sorted(words_counter, key=words_counter.get, reverse=True)
        vocab_to_int = {word:i for i,word in enumerate(unique_words)}
        int_vocab = {i:word for i,word in enumerate(unique_words)}
        return vocab_to_int, int_vocab

    """
    DON'T MODIFY ANYTHING IN THIS CELL THAT IS BELOW THIS LINE
    """
    tests.test_create_lookup_tables(create_lookup_tables)

    Tests Passed

### Tokenize Punctuation¶

We'll be splitting the script into a word array using spaces as delimiters. However, punctuations like periods and exclamation marks make it hard for the neural network to distinguish between the word "bye" and "bye!".

Implement the function `token_lookup` to return a dict that will be used to tokenize symbols like "!" into "||Exclamation_Mark||". Create a dictionary for the following symbols where the symbol is the key and value is the token:

- Period ( . )
- Comma ( , )
- Quotation Mark ( " )
- Semicolon ( ; )
- Exclamation mark ( ! )
- Question mark ( ? )
- Left Parentheses ( ( )
- Right Parentheses ( ) )
- Dash ( -- )
- Return ( \n )

This dictionary will be used to token the symbols and add the delimiter (space) around it. This separates the symbols as it's own word, making it easier for the neural network to predict on the next word. Make sure you don't use a token that could be confused as a word. Instead of using the token "dash", try using something like "||dash||".

In [12]:

    def token_lookup():
        """
        Generate a dict to turn punctuation into a token.
        :return: Tokenize dictionary where the key is the punctuation and the value is the token
        """
        # TODO: Implement Function
        return {'--': '||dash||',
                ',': '||comma||',
                '.': '||period||',
                '(': '||leftp||',
                ')': '||rightp||',
                ';': '||semicolon||',
                '?': '||question||',
                '\n': '||return||',
                '"': '||quotation||',
                '!': '||exclamation||'}

    """
    DON'T MODIFY ANYTHING IN THIS CELL THAT IS BELOW THIS LINE
    """
    tests.test_tokenize(token_lookup)

    Tests Passed

## Preprocess all the data and save it¶

Running the code cell below will preprocess all the data and save it to file.

In [13]:

    """
    DON'T MODIFY ANYTHING IN THIS CELL
    """
    # Preprocess Training, Validation, and Testing Data
    helper.preprocess_and_save_data(data_dir, token_lookup, create_lookup_tables)

# Check Point¶

This is your first checkpoint. If you ever decide to come back to this notebook or have to restart the notebook, you can start from here. The preprocessed data has been saved to disk.

In [14]:

    """
    DON'T MODIFY ANYTHING IN THIS CELL
    """
    import helper
    import numpy as np
    import problem_unittests as tests

    int_text, vocab_to_int, int_to_vocab, token_dict = helper.load_preprocess()

## Build the Neural Network¶

You'll build the components necessary to build a RNN by implementing the following functions below:

- get_inputs
- get_init_cell
- get_embed
- build_rnn
- build_nn
- get_batches

### Check the Version of TensorFlow and Access to GPU¶

In [15]:

    """
    DON'T MODIFY ANYTHING IN THIS CELL
    """
    from distutils.version import LooseVersion
    import warnings
    import tensorflow as tf

    # Check TensorFlow Version
    assert LooseVersion(tf.__version__) >= LooseVersion('1.3'), 'Please use TensorFlow version 1.3 or newer'
    print('TensorFlow Version: {}'.format(tf.__version__))

    # Check for a GPU
    if not tf.test.gpu_device_name():
        warnings.warn('No GPU found. Please use a GPU to train your neural network.')
    else:
        print('Default GPU Device: {}'.format(tf.test.gpu_device_name()))

    TensorFlow Version: 1.3.0
    Default GPU Device: /gpu:0

### Input¶

Implement the `get_inputs()` function to create TF Placeholders for the Neural Network. It should create the following placeholders:

- Input text placeholder named "input" using the TF Placeholder `name` parameter.
- Targets placeholder
- Learning Rate placeholder

Return the placeholders in the following tuple `(Input, Targets, LearningRate)`

In [16]:

    def get_inputs():
        """
        Create TF Placeholders for input, targets, and learning rate.
        :return: Tuple (input, targets, learning rate)
        """
        # TODO: Implement Function
        input = tf.placeholder(tf.int32,[None,None],name="input")
        targets = tf.placeholder(tf.int32,[None,None],name="targets")
        learning_rate = tf.placeholder(tf.float32,name="learning_rate")
        return input, targets, learning_rate

    """
    DON'T MODIFY ANYTHING IN THIS CELL THAT IS BELOW THIS LINE
    """
    tests.test_get_inputs(get_inputs)

    Tests Passed

### Build RNN Cell and Initialize¶

Stack one or more `BasicLSTMCells` in a `MultiRNNCell`.

- The Rnn size should be set using `rnn_size`
- Initalize Cell State using the MultiRNNCell's `zero_state()` function
  - Apply the name "initial_state" to the initial state using `tf.identity()`

Return the cell and initial state in the following tuple `(Cell, InitialState)`

In [17]:

    def get_init_cell(batch_size, rnn_size):
        """
        Create an RNN Cell and initialize it.
        :param batch_size: Size of batches
        :param rnn_size: Size of RNNs
        :return: Tuple (cell, initialize state)
        """
        lstm_layers = 1

        def build_cell(rnn_size, keep_prob=None):
            lstm = tf.contrib.rnn.BasicLSTMCell(rnn_size)
            #drop = tf.contrib.rnn.DropoutWrapper(lstm, output_keep_prob=keep_prob)
            return lstm

        cell = tf.contrib.rnn.MultiRNNCell([build_cell(rnn_size) for _ in range(lstm_layers)])
        initial_state = cell.zero_state(batch_size, tf.float32)
        initial_state = tf.identity(initial_state,name='initial_state')

        return cell, initial_state

    """
    DON'T MODIFY ANYTHING IN THIS CELL THAT IS BELOW THIS LINE
    """
    tests.test_get_init_cell(get_init_cell)

    Tests Passed

### Word Embedding¶

Apply embedding to `input_data` using TensorFlow. Return the embedded sequence.

In [18]:

    def get_embed(input_data, vocab_size, embed_dim):
        """
        Create embedding for <input_data>.
        :param input_data: TF placeholder for text input.
        :param vocab_size: Number of words in vocabulary.
        :param embed_dim: Number of embedding dimensions
        :return: Embedded input.
        """
        # TODO: Implement Function
        embed = tf.Variable(tf.random_normal((vocab_size,embed_dim),-0.01,0.01))
        return tf.nn.embedding_lookup(embed,input_data)

    """
    DON'T MODIFY ANYTHING IN THIS CELL THAT IS BELOW THIS LINE
    """
    tests.test_get_embed(get_embed)

    Tests Passed

### Build RNN¶

You created a RNN Cell in the `get_init_cell()` function. Time to use the cell to create a RNN.

- Build the RNN using the `tf.nn.dynamic_rnn()`
  - Apply the name "final_state" to the final state using `tf.identity()`

Return the outputs and final_state state in the following tuple `(Outputs, FinalState)`

In [19]:

    def build_rnn(cell, inputs):
        """
        Create a RNN using a RNN Cell
        :param cell: RNN Cell
        :param inputs: Input text data
        :return: Tuple (Outputs, Final State)
        """
        # TODO: Implement Function
        outputs, final_state = tf.nn.dynamic_rnn(cell,inputs,dtype=tf.float32)
        final_state = tf.identity(final_state, name='final_state')
        return outputs, final_state

    """
    DON'T MODIFY ANYTHING IN THIS CELL THAT IS BELOW THIS LINE
    """
    tests.test_build_rnn(build_rnn)

    Tests Passed

### Build the Neural Network¶

Apply the functions you implemented above to:

- Apply embedding to `input_data` using your `get_embed(input_data, vocab_size, embed_dim)` function.
- Build RNN using `cell` and your `build_rnn(cell, inputs)` function.
- Apply a fully connected layer with a linear activation and `vocab_size` as the number of outputs.

Return the logits and final state in the following tuple (Logits, FinalState)

In [20]:

    def build_nn(cell, rnn_size, input_data, vocab_size, embed_dim):
        """
        Build part of the neural network
        :param cell: RNN cell
        :param rnn_size: Size of rnns
        :param input_data: Input data
        :param vocab_size: Vocabulary size
        :param embed_dim: Number of embedding dimensions
        :return: Tuple (Logits, FinalState)
        """
        # TODO: Implement Function
        embed = get_embed(input_data, vocab_size, embed_dim)
        outputs, final_state = build_rnn(cell, embed)
        logits = tf.contrib.layers.fully_connected(outputs, vocab_size, activation_fn=None)
        return logits, final_state

    """
    DON'T MODIFY ANYTHING IN THIS CELL THAT IS BELOW THIS LINE
    """
    tests.test_build_nn(build_nn)

    Tests Passed

### Batches¶

Implement `get_batches` to create batches of input and targets using `int_text`. The batches should be a Numpy array with the shape `(number of batches, 2, batch size, sequence length)`. Each batch contains two elements:

- The first element is a single batch of input with the shape `[batch size, sequence length]`
- The second element is a single batch of targets with the shape `[batch size, sequence length]`

If you can't fill the last batch with enough data, drop the last batch.

For example, `get_batches([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20], 3, 2)` would return a Numpy array of the following:

    [
      # First Batch
      [
        # Batch of Input
        [[ 1  2], [ 7  8], [13 14]]
        # Batch of targets
        [[ 2  3], [ 8  9], [14 15]]
      ]

      # Second Batch
      [
        # Batch of Input
        [[ 3  4], [ 9 10], [15 16]]
        # Batch of targets
        [[ 4  5], [10 11], [16 17]]
      ]

      # Third Batch
      [
        # Batch of Input
        [[ 5  6], [11 12], [17 18]]
        # Batch of targets
        [[ 6  7], [12 13], [18  1]]
      ]
    ]

Notice that the last target value in the last batch is the first input value of the first batch. In this case, `1`. This is a common technique used when creating sequence batches, although it is rather unintuitive.

In [21]:

    def get_batches(int_text, batch_size, seq_length):
        """
        Return batches of input and target
        :param int_text: Text with the words replaced by their ids
        :param batch_size: The size of batch
        :param seq_length: The length of sequence
        :return: Batches as a Numpy array
        """
        num_batches = len(int_text) // (batch_size * seq_length)
        int_text[num_batches*batch_size*seq_length] = int_text[0]
        #print(int_text)
        batches = np.zeros([num_batches, 2, batch_size, seq_length], dtype=np.int32)
        for idx in range(0, len(int_text), seq_length):
            batch_no = (idx // seq_length) % num_batches
            batch_idx = idx // (seq_length * num_batches)
            if (batch_idx == batch_size):
                break
            batches[batch_no, 0, batch_idx, ] = int_text[idx:idx + seq_length]
            batches[batch_no, 1, batch_idx, ] = int_text[idx + 1:idx + seq_length + 1]
        return batches

    """
    DON'T MODIFY ANYTHING IN THIS CELL THAT IS BELOW THIS LINE
    """
    tests.test_get_batches(get_batches)

    Tests Passed

## Neural Network Training¶

### Hyperparameters¶

Tune the following parameters:

- Set `num_epochs` to the number of epochs.
- Set `batch_size` to the batch size.
- Set `rnn_size` to the size of the RNNs.
- Set `embed_dim` to the size of the embedding.
- Set `seq_length` to the length of sequence.
- Set `learning_rate` to the learning rate.
- Set `show_every_n_batches` to the number of batches the neural network should print progress.

In [22]:

    # Number of Epochs
    num_epochs = 125
    # Batch Size
    batch_size = 200
    # RNN Size
    rnn_size = 512
    # Embedding Dimension Size
    embed_dim = 300
    # Sequence Length
    seq_length = 40
    # Learning Rate
    learning_rate = 0.01
    # Show stats for every n number of batches
    show_every_n_batches = 16

    """
    DON'T MODIFY ANYTHING IN THIS CELL THAT IS BELOW THIS LINE
    """
    save_dir = './save'

### Build the Graph¶

Build the graph using the neural network you implemented.

In [23]:

    """
    DON'T MODIFY ANYTHING IN THIS CELL
    """
    from tensorflow.contrib import seq2seq

    train_graph = tf.Graph()
    with train_graph.as_default():
        vocab_size = len(int_to_vocab)
        input_text, targets, lr = get_inputs()
        input_data_shape = tf.shape(input_text)
        cell, initial_state = get_init_cell(input_data_shape[0], rnn_size)
        logits, final_state = build_nn(cell, rnn_size, input_text, vocab_size, embed_dim)

        # Probabilities for generating words
        probs = tf.nn.softmax(logits, name='probs')

        # Loss function
        cost = seq2seq.sequence_loss(
            logits,
            targets,
            tf.ones([input_data_shape[0], input_data_shape[1]]))

        # Optimizer
        optimizer = tf.train.AdamOptimizer(lr)

        # Gradient Clipping
        gradients = optimizer.compute_gradients(cost)
        capped_gradients = [(tf.clip_by_value(grad, -1., 1.), var) for grad, var in gradients if grad is not None]
        train_op = optimizer.apply_gradients(capped_gradients)

## Train¶

Train the neural network on the preprocessed data. If you have a hard time getting a good loss, check the forums to see if anyone is having the same problem.

In [24]:

    """
    DON'T MODIFY ANYTHING IN THIS CELL
    """
    batches = get_batches(int_text, batch_size, seq_length)

    with tf.Session(graph=train_graph) as sess:
        sess.run(tf.global_variables_initializer())

        for epoch_i in range(num_epochs):
            state = sess.run(initial_state, {input_text: batches[0][0]})

            for batch_i, (x, y) in enumerate(batches):
                feed = {
                    input_text: x,
                    targets: y,
                    initial_state: state,
                    lr: learning_rate}
                train_loss, state, _ = sess.run([cost, final_state, train_op], feed)

                # Show every <show_every_n_batches> batches
                if (epoch_i * len(batches) + batch_i) % show_every_n_batches == 0:
                    print('Epoch {:>3} Batch {:>4}/{}   train_loss = {:.3f}'.format(
                        epoch_i,
                        batch_i,
                        len(batches),
                        train_loss))

        # Save Model
        saver = tf.train.Saver()
        saver.save(sess, save_dir)
        print('Model Trained and Saved')

    Epoch   0 Batch    0/8   train_loss = 8.822
    Epoch   2 Batch    0/8   train_loss = 5.754
    Epoch   4 Batch    0/8   train_loss = 5.223
    Epoch   6 Batch    0/8   train_loss = 4.692
    Epoch   8 Batch    0/8   train_loss = 4.277
    Epoch  10 Batch    0/8   train_loss = 3.942
    Epoch  12 Batch    0/8   train_loss = 3.584
    Epoch  14 Batch    0/8   train_loss = 3.260
    Epoch  16 Batch    0/8   train_loss = 3.009
    Epoch  18 Batch    0/8   train_loss = 2.820
    Epoch  20 Batch    0/8   train_loss = 2.555
    Epoch  22 Batch    0/8   train_loss = 2.254
    Epoch  24 Batch    0/8   train_loss = 2.042
    Epoch  26 Batch    0/8   train_loss = 1.880
    Epoch  28 Batch    0/8   train_loss = 1.722
    Epoch  30 Batch    0/8   train_loss = 1.594
    Epoch  32 Batch    0/8   train_loss = 1.465
    Epoch  34 Batch    0/8   train_loss = 1.417
    Epoch  36 Batch    0/8   train_loss = 1.257
    Epoch  38 Batch    0/8   train_loss = 1.098
    Epoch  40 Batch    0/8   train_loss = 0.966
    Epoch  42 Batch    0/8   train_loss = 0.877
    Epoch  44 Batch    0/8   train_loss = 0.869
    Epoch  46 Batch    0/8   train_loss = 0.814
    Epoch  48 Batch    0/8   train_loss = 0.883
    Epoch  50 Batch    0/8   train_loss = 0.687
    Epoch  52 Batch    0/8   train_loss = 0.568
    Epoch  54 Batch    0/8   train_loss = 0.476
    Epoch  56 Batch    0/8   train_loss = 0.433
    Epoch  58 Batch    0/8   train_loss = 0.379
    Epoch  60 Batch    0/8   train_loss = 0.363
    Epoch  62 Batch    0/8   train_loss = 0.318
    Epoch  64 Batch    0/8   train_loss = 0.269
    Epoch  66 Batch    0/8   train_loss = 0.245
    Epoch  68 Batch    0/8   train_loss = 0.222
    Epoch  70 Batch    0/8   train_loss = 0.204
    Epoch  72 Batch    0/8   train_loss = 0.177
    Epoch  74 Batch    0/8   train_loss = 0.160
    Epoch  76 Batch    0/8   train_loss = 0.143
    Epoch  78 Batch    0/8   train_loss = 0.130
    Epoch  80 Batch    0/8   train_loss = 0.120
    Epoch  82 Batch    0/8   train_loss = 0.113
    Epoch  84 Batch    0/8   train_loss = 0.107
    Epoch  86 Batch    0/8   train_loss = 0.101
    Epoch  88 Batch    0/8   train_loss = 0.096
    Epoch  90 Batch    0/8   train_loss = 0.091
    Epoch  92 Batch    0/8   train_loss = 0.086
    Epoch  94 Batch    0/8   train_loss = 0.083
    Epoch  96 Batch    0/8   train_loss = 0.080
    Epoch  98 Batch    0/8   train_loss = 0.078
    Epoch 100 Batch    0/8   train_loss = 0.076
    Epoch 102 Batch    0/8   train_loss = 0.074
    Epoch 104 Batch    0/8   train_loss = 0.072
    Epoch 106 Batch    0/8   train_loss = 0.071
    Epoch 108 Batch    0/8   train_loss = 0.070
    Epoch 110 Batch    0/8   train_loss = 0.068
    Epoch 112 Batch    0/8   train_loss = 0.068
    Epoch 114 Batch    0/8   train_loss = 0.067
    Epoch 116 Batch    0/8   train_loss = 0.066
    Epoch 118 Batch    0/8   train_loss = 0.065
    Epoch 120 Batch    0/8   train_loss = 0.065
    Epoch 122 Batch    0/8   train_loss = 0.064
    Epoch 124 Batch    0/8   train_loss = 0.064
    Model Trained and Saved

## Save Parameters¶

Save `seq_length` and `save_dir` for generating a new TV script.

In [25]:

    """
    DON'T MODIFY ANYTHING IN THIS CELL
    """
    # Save parameters for checkpoint
    helper.save_params((seq_length, save_dir))

# Checkpoint¶

In [26]:

    """
    DON'T MODIFY ANYTHING IN THIS CELL
    """
    import tensorflow as tf
    import numpy as np
    import helper
    import problem_unittests as tests

    _, vocab_to_int, int_to_vocab, token_dict = helper.load_preprocess()
    seq_length, load_dir = helper.load_params()

## Implement Generate Functions¶

### Get Tensors¶

Get tensors from `loaded_graph` using the function `get_tensor_by_name()`. Get the tensors using the following names:

- "input:0"
- "initial_state:0"
- "final_state:0"
- "probs:0"

Return the tensors in the following tuple `(InputTensor, InitialStateTensor, FinalStateTensor, ProbsTensor)`

In [27]:

    def get_tensors(loaded_graph):
        """
        Get input, initial state, final state, and probabilities tensor from <loaded_graph>
        :param loaded_graph: TensorFlow graph loaded from file
        :return: Tuple (InputTensor, InitialStateTensor, FinalStateTensor, ProbsTensor)
        """
        # TODO: Implement Function
        return (loaded_graph.get_tensor_by_name("input:0"),
                loaded_graph.get_tensor_by_name("initial_state:0"),
                loaded_graph.get_tensor_by_name("final_state:0"),
                loaded_graph.get_tensor_by_name("probs:0"))

    """
    DON'T MODIFY ANYTHING IN THIS CELL THAT IS BELOW THIS LINE
    """
    tests.test_get_tensors(get_tensors)

    Tests Passed

### Choose Word¶

Implement the `pick_word()` function to select the next word using `probabilities`.

In [28]:

    def pick_word(probabilities, int_to_vocab):
        """
        Pick the next word in the generated text
        :param probabilities: Probabilites of the next word
        :param int_to_vocab: Dictionary of word ids as the keys and words as the values
        :return: String of the predicted word
        """
        # TODO: Implement Function
        p = np.squeeze(probabilities)
        top_n = min(5,p.shape[0])
        p[np.argsort(p)[:-top_n]] = 0
        p = p / np.sum(p)
        index = np.random.choice(p.shape[0], 1, p=p)[0]
        return int_to_vocab[index]

    """
    DON'T MODIFY ANYTHING IN THIS CELL THAT IS BELOW THIS LINE
    """
    tests.test_pick_word(pick_word)

    Tests Passed

## Generate TV Script¶

This will generate the TV script for you. Set `gen_length` to the length of TV script you want to generate.

In [29]:

    gen_length = 200
    # homer_simpson, moe_szyslak, or Barney_Gumble
    prime_word = 'moe_szyslak'

    """
    DON'T MODIFY ANYTHING IN THIS CELL THAT IS BELOW THIS LINE
    """
    loaded_graph = tf.Graph()
    with tf.Session(graph=loaded_graph) as sess:
        # Load saved model
        loader = tf.train.import_meta_graph(load_dir + '.meta')
        loader.restore(sess, load_dir)

        # Get Tensors from loaded model
        input_text, initial_state, final_state, probs = get_tensors(loaded_graph)

        # Sentences generation setup
        gen_sentences = [prime_word + ':']
        prev_state = sess.run(initial_state, {input_text: np.array([[1]])})

        # Generate sentences
        for n in range(gen_length):
            # Dynamic Input
            dyn_input = [[vocab_to_int[word] for word in gen_sentences[-seq_length:]]]
            dyn_seq_length = len(dyn_input[0])

            # Get Prediction
            probabilities, prev_state = sess.run(
                [probs, final_state],
                {input_text: dyn_input, initial_state: prev_state})

            pred_word = pick_word(probabilities[0][dyn_seq_length-1], int_to_vocab)

            gen_sentences.append(pred_word)

        # Remove tokens
        tv_script = ' '.join(gen_sentences)
        for key, token in token_dict.items():
            ending = ' ' if key in ['\n', '(', '"'] else ''
            tv_script = tv_script.replace(' ' + token.lower(), key)
        tv_script = tv_script.replace('\n ', '\n')
        tv_script = tv_script.replace('( ', '(')

        print(tv_script)

    INFO:tensorflow:Restoring parameters from ./save
    moe_szyslak: okay it's over! get 'em out of here!
    moe_szyslak:(to bears) all right, andalay! andalay!

    homer_simpson: sometimes you gotta go where everybody knows your name.
    homer_simpson:(impressed) ooh," general!"(beat) who's drederick tatum, anyway? is he another hobo?
    moe_szyslak:(evasive) yeah, that's give you back, you're answering to me! and there's gonna be big changes.
    moe_szyslak: whoa, whoa, whoa, now wait just a minute. one?
    homer_simpson:(terrified noise) the woman i love!
    marge_simpson: i wonder what's keeping carl?
    homer_simpson: no way.
    homer_simpson: not a thing in the world.
    moe_szyslak: yeah, i wish i could say the same.
    homer_simpson: moe, this was back before snake became a notorious jailbird, when he was an idealistic, law-abiding young archaeologist...
    apu_nahasapeemapetilon: such a voice!
    seymour_skinner: who is that?
    barney_gumble: i had a feeling you'd say that.(stagy) so i

# The TV Script is Nonsensical¶

It's ok if the TV script doesn't make any sense. We trained on less than a megabyte of text. In order to get good results, you'll have to use a smaller vocabulary or get more data. Luckily there's more data! As we mentioned in the beggining of this project, this is a subset of another dataset. We didn't have you train on all the data, because that would take too long. However, you are free to train your neural network on all the data. After you complete the project, of course.

# Submitting This Project¶

When submitting this project, make sure to run all the cells before saving the notebook. Save the notebook file as "dlnd_tv_script_generation.ipynb" and save it as a HTML file under "File" -> "Download as". Include the "helper.py" and "problem_unittests.py" files in your submission.